<copyright> MU unit lexer.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright (C) 1996 Pieter J. Schoenmakers.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA

    <id>$Id: LexUnit.t,v 1.7 1998/04/26 22:47:07 tiggr Exp $</id>
    </copyright>

implementation class
LexUnit: Lexer, ParseUnitDefines

void
  fillTokens
{
  [self addToken ("class", CLASS)];
  [self addToken ("end", END)];
  [self addToken ("extension", EXTENSION)];
  [self addToken ("file", FILE)];
  [self addToken ("identifier", IDENTIFIER)];
  [self addToken ("posing", POSING)];
  [self addToken ("unit", UNIT)];
  [self addToken ("uses", USES)];
}

end;

implementation instance
LexUnit

int
  character
{
  = CHARACTER;
}

int
  identifier
{
  // semantics has the wrong type...
  // Fri Oct  4 22:47:07 1996, tiggr@jaguar.ics.ele.tue.nl
  semantics = Any ([UniqueString with String (semantics)]);
  Token t = tokens[semantics];

  = !t ? IDENTIFIER : [t token];
}

int
  number
{
  = NUMBER;
}

int
  string
{
  = STRING;
}

end;
